summaryrefslogtreecommitdiff
path: root/tests/misc/sort-rand
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2005-12-10 09:37:21 +0000
committerJim Meyering <jim@meyering.net>2005-12-10 09:37:21 +0000
commit7de48ccced45e038456dac12a9e7d48f7c33dd1f (patch)
treef9772ca48d67e281a329244a0c13132d750996f7 /tests/misc/sort-rand
parentf9b90d0739e2cf56ad7462a9c5b3cbdc2ec97123 (diff)
downloadcoreutils-7de48ccced45e038456dac12a9e7d48f7c33dd1f.tar.xz
Add a basic test of the new options.
Diffstat (limited to 'tests/misc/sort-rand')
-rwxr-xr-xtests/misc/sort-rand37
1 files changed, 37 insertions, 0 deletions
diff --git a/tests/misc/sort-rand b/tests/misc/sort-rand
new file mode 100755
index 000000000..8a515e732
--- /dev/null
+++ b/tests/misc/sort-rand
@@ -0,0 +1,37 @@
+#!/bin/sh
+# Ensure that sort --sort-random doesn't sort.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ sort --version
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+seq 100 > in || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+sort --seed=$$ --random-sort in > out || fail=1
+
+# Fail if the input is the same as the output.
+# This is a probabilistic test :-)
+# However, the odds of failure are very low: 1 in 100! (~ 1 in 10^158)
+cmp in out > /dev/null && { fail=1; echo "not random?" 1>&2; }
+
+# Fail if the sorted output is not the same as the input.
+sort -n out > out1
+cmp in out1 || { fail=1; echo "not a permutation" 1>&2; }
+
+(exit $fail); exit $fail